	.686
	.model flat, stdcall
	option casemap :none
	
	include \masm32\include\ntdll.inc
	includelib \masm32\lib\ntdll.lib

	include \masm32\include\kernel32.inc
	includelib \masm32\lib\kernel32.lib

	OPT_DEBUG			equ TRUE
.code
	include Kite\KiteH.inc
	include Kite\Builder.inc
	include Kite\Kitb.inc
	include Kite\Macros.inc

	include Header.inc
	include Misc.asm
	include Image.asm
	include Tree.asm

.data
gView		MMVIEW <>

.code
; +
; P = LdrpInitialize()
;
ViQueryA proc uses ebx esi
	mov ebx,TRUE
@@:
	invoke RtlEnumerateGenericTableAvl, addr gView.Ltree, Ebx
	xor ebx,ebx
	.if Eax
		mov esi,LTE.Link[eax]
		invoke LdrCalcHash, Esi, 20
		cmp eax,658A730BH	; "BaseQueryModuleData", 0
		jne @b
		inc ebx
	@@:
		invoke ViEnumFixups, addr gView.Rtree, Esi, Ebx
		xor ebx,ebx
		.if Eax
			mov eax,RTE.Fixup[eax]
			cmp W[eax][-6],85C7H
			jne @b
			add eax,4	; Ip'
		.endif
	.endif
	ret
ViQueryA endp

; +
; P = LdrpInitializeTls()
;
ViQueryB proc uses ebx esi
	mov ebx,TRUE
@@:
	invoke RtlEnumerateGenericTableAvl, addr gView.Ltree, Ebx
	xor ebx,ebx
	.if Eax
		mov esi,LTE.Link[eax]
		invoke LdrCalcHash, Esi, 18
		cmp eax,532703F3H	; "LdrpInitializeTls", 0
		je @f
		cmp eax,6F230037H	; "LDR: Tls Found in "
		jne @b
	@@:
		inc ebx
	@@:
		invoke ViEnumFixups, addr gView.Rtree, Esi, Ebx
		xor ebx,ebx
		.if Eax
			mov eax,RTE.Fixup[eax]
			cmp B[eax][-1],68H
			jne @b
			add eax,4	; Ip'
		.endif
	.endif
	ret
ViQueryB endp

%ZERR macro
	.if !Eax
		Int 3
	.endif
endm

EXTERN _imp__ZwQueryInformationProcess@20:DWORD
EXTERN _imp__ZwClose@4:DWORD

; +
;
GpToEntry proc J:PGPENTRY
	mov eax,J
	assume eax:PGPENTRY
Walk:
	%HEAD Eax
	%DBG "Flow 0x%X", [Eax].Ip
	
	lea eax,[eax].Rlist
	%LGET Eax
	mov eax,D[eax]
	btr eax,GPF_LAST
	mov ecx,GPENTRY.Flags[eax]
	and ecx,GPF_MASK_TYPE
	shr ecx,2
	cmp cl,TYPE_UCALL
	jne Walk
	mov eax,[eax].FlowIp
	ret
GpToEntry endp

; +
;	
ViQueryTls proc
Local Store:PGPSTORE
comment '
	Bad construction in one entry(for test dll):
	
	ZwQueryInformationProcess:
			mov eax,0x19
			Call S1
			00 00 28 4B	<-- data after call.
		S1:
			pop edx
			cmp B[edx][3],4B
			...'
			
	mov esi,D[_imp__ZwQueryInformationProcess@20]
	mov edi,D[_imp__ZwClose@4]
	
	.if B[Esi] != 0B8H
		Int 3
	.endif

	add esi,5
	
	invoke _ProtectForBuild, Esi, 5, PAGE_EXECUTE_READWRITE
	
	mov B[esi][0],0E9H
	sub edi,esi
	mov D[esi][1],edi
	
	invoke _ProtectForBuild, Esi, 5, PAGE_EXECUTE_READ

	invoke ViQueryA
	%DBG "P_LdrpInitialize 0x%X", Eax
	%ZERR

	push 0
	push 1	; NL
	push eax
	push 8	; Portion
	push offset _Free
	push offset _Alloc
	%CKITE KID_KIT
	mov Store,eax
	%DBG "KIT(LdrpInitialize) 0x%X", Eax
	%ZERR
	
	invoke ViQueryB
	%DBG "P_LdrpInitializeTls 0x%X", Eax
	%ZERR
	
	push eax
	push Store
	%CKITE KID_FIND_ENTRY
	%DBG "KID_FIND_ENTRY 0x%X", Eax
	%ZERR
	
	invoke GpToEntry, Eax
	%DBG "LdrpInitializeTls() 0x%X", Eax
	%ZERR
	push eax
	
	push offset _Free
	push Store
	%CKITE KID_FREE_STORE
	
	pop eax
	ret
ViQueryTls endp

$Dll	CHAR "tls.dll", 0
				
Thread proc P:PVOID
	ret
Thread endp

EP proc uses ebx esi edi
Local Tid:ULONG
	invoke LoadLibrary, addr $Dll
	
	invoke LdrGetNativeBase
	invoke ViInitialize, Eax, addr gView

	invoke RtlNumberGenericTableElementsAvl, addr gView.Ltree
	%DBG "L-tree 0x%X", Eax
	
	invoke RtlNumberGenericTableElementsAvl, addr gView.Rtree
	%DBG "R-tree 0x%X", Eax

	invoke ViQueryTls

	Call Eax

	invoke CreateThread, 0, 0, addr Thread, 0, 0, addr Tid
	ret
EP endp
end EP